/*
 * Copyright 2017 Red Hat, Inc. and/or its affiliates.
 *
 * Licensed under the Apache License, Version 2.0 (the "License");
 * you may not use this file except in compliance with the License.
 * You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS,
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 * See the License for the specific language governing permissions and
 * limitations under the License.
 */

package org.kie.workbench.common.stunner.core.rule.context.impl;

import org.kie.workbench.common.stunner.core.graph.Graph;
import org.kie.workbench.common.stunner.core.graph.Node;
import org.kie.workbench.common.stunner.core.rule.context.GraphEvaluationContext;

abstract class AbstractGraphEvaluationContext implements GraphEvaluationContext {

    private final String name;
    private final Graph<?, ? extends Node> graph;

    protected AbstractGraphEvaluationContext(final String name,
                                             final Graph<?, ? extends Node> graph) {
        this.name = name;
        this.graph = graph;
    }

    @Override
    public Graph<?, ? extends Node> getGraph() {
        return graph;
    }

    @Override
    public String getName() {
        return name;
    }
}
